SystemOrganization addCategory: #'Light-Out'!

SimpleSwitchMorph subclass: #LOCell2
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Light-Out'!

!LOCell2 methodsFor: 'initialization' stamp: 'Aria2end 5/28/2014 16:37'!
initialize
super initialize.
self label: ''.
self borderWidth: 2.
bounds := 0@0 corner: 16@16.
offColor := Color paleYellow.
onColor := Color paleBlue darker.
self useSquareCorners.
self turnOff.! !

!LOCell2 methodsFor: 'initialization' stamp: 'Aria2end 5/29/2014 00:27'!
mouseAction: aBlock
^mouseAction := aBlock.! !

!LOCell2 methodsFor: 'initialization' stamp: 'Aria2end 5/29/2014 00:28'!
mouseUp: anEvent
mouseAction value! !

BorderedMorph subclass: #LOGame2
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Light-Out'!

!LOGame2 methodsFor: 'initialization' stamp: 'Aria2end 5/29/2014 00:36'!
cellsPerSide
^10! !

!LOGame2 methodsFor: 'initialization' stamp: 'Aria2end 5/29/2014 00:42'!
initialize
| sampleCell width height n |
super initialize.
n := self cellsPerSide.
sampleCell := LOCell2 new.
width := sampleCell width.
height := sampleCell height.
self bounds: (10@10 extent: ((width*n) @(height*n)) + (2 *self borderWidth)).
cells := Matrix new: n tabulate: [ :i :j | self newCellAt: i at: j ].! !

!LOGame2 methodsFor: 'initialization' stamp: 'Aria2end 5/29/2014 00:43'!
newCellAt: i at: j
"Create a cell for position (i,j) and add it to my on−screen
representation at the appropriate screen position. Answer the new cell"
| c origin |
c := LOCell2 new.
origin := self innerBounds origin.
self addMorph: c.
c position: ((i - 1)*c width) @ ((j - 1)*c height) + origin.
c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
^c! !

!LOGame2 methodsFor: 'initialization' stamp: 'Aria2end 5/29/2014 00:26'!
toggleNeighboursOfCellAt: i at: j
(i > 1) ifTrue: [ (cells at: i - 1 at: j ) toggleState].
(i < self cellsPerSide) ifTrue: [ (cells at: i + 1 at: j) toggleState].
(j > 1) ifTrue: [ (cells at: i at: j - 1) toggleState].
(j < self cellsPerSide) ifTrue: [ (cells at: i at: j + 1) toggleState]! !
